Module | Enumerable
In: | lib/active_support/core_ext/enumerable.rb lib/active_support/json/encoders/enumerable.rb

### Methods

group_by index_by sum

### Public Instance methods

group_by() {|element| ...}

Collect an enumerable into sets, grouped by the result of a block. Useful, for example, for grouping records by date.

Example:

      latest_transcripts.group_by(&:day).each do |day, transcripts|
        p "#{day} -> #{transcripts.map(&:class).join(', ')}"
      end
      "2006-03-01 -> Transcript"
      "2006-02-28 -> Transcript"
      "2006-02-27 -> Transcript, Transcript"
      "2006-02-26 -> Transcript, Transcript"
      "2006-02-25 -> Transcript"
      "2006-02-24 -> Transcript, Transcript"
      "2006-02-23 -> Transcript"

index_by() {|elem| ...}

Convert an enumerable to a hash. Examples:

      people.index_by(&:login)
        => { "nextangle" => <Person ...>, "chade-" => <Person ...>, ...}
      people.index_by { |person| "#{person.first_name} #{person.last_name}" }
        => { "Chade- Fowlersburg-e" => <Person ...>, "David Heinemeier Hansson" => <Person ...>, ...}

sum(identity = 0, &block)

Calculates a sum from the elements. Examples:

     payments.sum { |p| p.price * p.tax_rate }
     payments.sum(&:price)

The latter is a shortcut for:

     payments.inject { |sum, p| sum + p.price }

It can also calculate the sum without the use of a block.

     [5, 15, 10].sum # => 30
     ["foo", "bar"].sum # => "foobar"
     [[1, 2], [3, 1, 5]].sum => [1, 2, 3, 1, 5]

The default sum of an empty list is zero. You can override this default:

     [].sum(Payment.new(0)) { |i| i.amount } # => Payment.new(0)

[Validate]